                                                         -*- coding: utf-8 -*-
   
Changes with httest 2.4.12
  *) httest: Bugfix error messages for websocket failures.

  *) httest: Bugfix possible core dump on log uninitialized data buffer.

  *) httest: Bugfix dso load error suppress error message.

  *) httest: New coder to escape regex special characters within strings to
             use them as literal strings within _EXPECT commands [Pascal
	     Buchbinder].


Changes with httest 2.4.11
  *) httest: _WS:SEND BINARY do now expect a string with hex digits example my
             look like _WS:SEND FIN,BINARY AUTO "00 01 02 03 04 05" this sends
	     6 bytes 0x00, 0x01, 0x02, 0x03, 0x04, 0x05
	     This change is not backward compatible.


Changes with httest 2.4.10
  *) shrinkwrap: Linux cubieboard build (ARM Cortex-A7)

  *) httest: Bugfix problems with older openssl version 0.9.8

  *) httest: New local commands are available in global sections as well.


Changes with httest 2.4.9
  *) httest: Fix multiline variable resolve problem.

  *) httest: Set mutex for global pool to make thread handling safe.

  *) httest: Mutex for worker clone


Changes with httest 2.4.8
  *) httest: Bugfix possible coredump for content pipe from/to _EXEC.
  
  *) httest: Bugfix wrong error trace and avoid another coredump in this
             context. Error trace no points to the end of a block instead to
	     the start of block where an error occured.

  *) httest: Bugfix coredump if daemon is using pools and httest exits on
             error.

  *) htproxy: Bugfix wrong initialized httest commands before calling them.


Changes with httest 2.4.7
  *) httest: Bugfix wrong error line number on windows

  *) httest: _DSO:FUNC method to call a load module function with the signature
             apr_status_t func(const char *string). Usefull to trigger stuff
	     in the loaded module.

  *) packages: shrinkwrap: make check reports
   

Changes with httest 2.4.6
  *) httest: Bugfix racecondition in _SH

  *) httest: Bugfix wrong error handling in websockets

  *) httest: Bugfix buffer overflow on 64-bit archs


Changes with httest 2.4.5
  *) httest: Add missing thread numbers on error if thread number log is
             turned on.

  *) httest: Bugfix possible deadlock on read.

  *) httest: Rename regexec, else a loaded transport module wich do use the
             posxi pcre will fail, because it will possible call the httest
	     regexec.

  *) httest: Bugfix found segfault thrown on illegal arguments. Reported by
             Eva Ramon.

  *) httest: Install include/htt/dso.h for dynamic transport object library.


Changes with httest 2.4.4
  *) httest: Bugfix possible coredump in ssl_module.c

  *) httest: Bugfix possible coredump in store.c

  *) httest: Add multiline variable support for _SET command

  *) httest: Experimental dynamic shared object support for transport objects.
             This could be very useful to test shared libraries directly with
             the wellknown httest commands.

  *) httest: Bugfix missing help text for module commands.

  *) httest: Bugfix overflow problem with websocket commands _WS:SEND and
             _WS:RECV.

  *) httest: Fixed broken _SSL:TRACE, add >,< again for in/out to make them
             expectable like before.

  *) httest: Fix broken identing after GO.


Changes with httest 2.4.3
  *) macros: Did cleanup the macros and document the interfaces. Mostly.

  *) scripts:Add pentester script folder. Read the pentester.htt how to
             initialize. Is able to handle the xssAttacks.xml, sqlAttacks.xml
	     and the filesAttacks.xml. Also a greate demonstration for the
	     _MILESTONE usage and show the capability of httest.

  *) hturl:  Removed, use _HTML:PARSE/_HTML:XPATH and _XML:PARSE/_XML:XPATH
             instead.

  *) htx2h:  Removed use _BINARY:SEND/_BINARY:RECV to send hex values
             directly.

  *) httest: All block calls can handle VAR(<variable>). If you hand over
             variables with VAR(<variable>) instead of $<variable> the
	     resolving is done afert calling.

  *) httest: A new _MILESTONE command makes it possible to run several sub
             tests in one script. The test will not fail in a milestone
	     section but will fail at the end with a statistic how many
	     milestone did run and how many failed. Is currently marked
	     experimental.

  *) httest: Bugfixed command _DEBUG which did not print anything at all.

  *) httest: Correct color on|off to avoid scrambled colors in some cases.

  *) httest: Improve _LOOP new it is possible to initialize the loop variable
             with an initial value. Default this is still 0.
  

Changes with httest 2.4.2
  *) httest: Add a change from Alain Stalder for coloring on windows.


Changes with httest 2.4.1
  *) httest: New you can close the body of _IF simply with a _END command
             instead with "_END IF".
  
  *) httest: Bugfixed _FOR command, if variable contains newline this also
             counts as separator.

  *) httest: Bugfix appender_std, threads messup colors

  *) httest: Bugfix appender_std, variable with newlines did messup output.


Changes with httest 2.4.0
  *) httest: Logger with appender concept introduced to be able to add and use
             different appenders. Default a standard appender is active.

  *) httest: Added colored output in the standard appender.

  *) httest: Fixed LOCK command which could lead to deadlock while
             SERVER/CLIENT start up, because all three used the same mutex.

  *) httest: Removed PROCESS, _PROCESS and the corresponding _PROC_WAIT from
             httest. This function are useless and do not work as expected.

  *) httest: Command _SOCKET is not used any more and is marked depreciated.
             you can remove this command without change your scripts behavour.


Changes with httest 2.3.3
  *) httest: Fixed segfault on httest -C <command-name> to print help text of
             a given command <command-name>.
  
  *) httest: Fixed the broken log output on various places due the refactoring
             for the thread safe output implementation in release 2.3.0.


Changes with httest 2.3.2
  *) httest: Add annotation to ignore/skip tests based on defined rules.
             Useful if tests do only run on certain machine or plattforms or
	     to tag slow tests.

  *) httest: Charset translation support.


Changes with httest 2.3.1
  *) httest: Various files were incorrect/incomplete, have to revoke 2.3.0

Changes with httest 2.3.0
  *) httest: Mutex based logger to avoid scattered lines. Add optional thread
             id to be able to sort the output of multi threaded tests.

Changes with httest 2.2.14
  *) httest: Bugfixed wrong length handling in websocket implementation.

Changes with httest 2.2.13
  *) httest: Adjust logging if calling unresolvable inline functions.

  *) httest: Bugfixed buggy _RPS command done by Steve Saunders.

  *) httest: Changed _DEBUG command to print allways no mather with log level.


Changes with httest 2.2.12
  *) httest: Distribute a server to a remote host, very usefull for
             integration testing, where a mock server must reside on a
	     specific host in a specific network zone.


Changes with httest 2.2.11
  *) httest: Bugfix possible coredump in thread tests with SSL.


Changes with httest 2.2.10
  *) httest: Add a check if _EXPECT are clean or include some unescaped
             quotes. Please adjust detected missformated _EXPECT.


Changes with httest 2.2.9
  *) httest: New commands REQUIRE_VERSION and REQUIRE_MODULE.


Changes with httest 2.2.8
  *) httest: Workaround for cert loading problem if server is threaded.

  *) plugins: Syntax highlighting for BBEdit/TextWrangler (Mac),
              Notepad++ (Win) and gedit/gtkSourceView (Linux).
  
  *) tools: htcolor Perl script to color httest output.


Changes with httest 2.2.7
  *) httest: Performance improvments around receiving and sending data.


Changes with httest 2.2.6
  *) httest: New RAMPUP command to control the start fo CLIENTS.

  *) httest: refactoring to enable global commands in modules.

  *) httest: _LOOP for a given time implemented, i.e. _LOOP 1000 [ms] loops
             for 1000 ms. Only [ms] implemented yet.

  *) httest: Bugfixed log body data.

  *) httest: Bugfixed possible coredump with lua blocks.

Changes with httest 2.2.5
  *) httest: Performance module for distributed client support.

  *) httest: Improvments suggested by sonar scann

  *) httest: Improved log performance with multi-threaded tests.

Changes with httest 2.2.4
  *) httest: Bugfix possible segfault with _SSL:TRACE


Changes with httest 2.2.3
  *) httest: Openssl 1.0.1 support.

  *) httest: Bugfixed global command GO which can be used now to join threads.

  *) httest: Expect/match/grep TLS extention messages

  *) httest: Get server cert also on "_SSL:RENEG_CERT" and do verification of
  this cert only on "_SSL:RENEG_CERT verify" 


Changes with httest 2.2.2
  *) httest: New SSL command to set cipher suite.

  *) httest: Expect/match/grep SSL handshake messages.


Changes with httest 2.2.1
  *) httest: New XPath command to query parts of the HTML document.

  *) httest: New variable scope GLOBAL. This variable are shared among all
             threads.


Changes with httest 2.2.0
  *) general: Forked from httest 2.1.19

  *) httest: Javascript BLOCK support

  *) httest: Improve formatings on output

  *) httest: Bugfix non working _SEQUENCE command and add a test for verify
             even the bad case

  *) httest: Add _ASSERT "<expression>" command for arithmetical assertions,
             cleaner and better readable than _IF ... _ELSE ... _END
	     constructs.


Changes with httest 2.1.18
  *) httest: Bugfix possible coredumps at temp file clean up and _EXEC.


Changes with httest 2.1.17
  *) httest: Read trailing headers after chunked body.

  *) httest: Support for variable definition in command line. You can now call
             httest -Dyour=var or in long from httest --define your=var of
	     course this is possible multiple time.

  *) httest: Started with a simple httest debuger. Can set breakpoint with
             _DBG:BP. On breakpoint a simple command line interpreter helps
	     you investigate your test. There is "cont" to continue test,
	     "quit" for quit test, "list" to geht list around breakpoint,
	     "set <var>=<ANY>" to set a variable and a "get <variable>" to get
	     the value of a variable even enviroment variables.


Changes with httest 2.1.16
  *) httest: Use a generic tokenize to argv for most commands. Quoted
             tokens are threaded as one parameter.

  *) httest: Improve _LOOP with an invariant.

  *) httest: PATH directiv to define paths for INCLUDE of relative include
             files.

  *) httest: More safestack fixes for openssl stuff.


Changes with httest 2.1.15
  *) httest: Add more functions for openssl x509 and dh stuff to Lua
             interface.
  
  *) httest: Bugfix variable substitution. With this bugfix you can emulate
             array and/or hash variables i.e. $my_array$i or $my_hash$entry.
	     The substitution will resolve $i and $entry first which results
	     in a new variable i.e $my_array0.

  *) httest: Bugfix safestack internals which leads to compile problems with 
             openssl.


Changes with httest 2.1.14
  *) httest: Fixed _SSL:RENEG_CERT Again. Without "verify" option
             _SSL:RENEG_CERT get certificate but still verified it. Now it is
	     possible to get a wrong client cert. It only do fail if there is
	     no client certificate. You can inspect the received client cert
	     with _SSL:GET_CERT_VALUE.

  *) htntlm: Fixed scannf call for 64 bit machines. On 64 bit machines
             uint64_t is no longer %llx but %lx


Changes with httest 2.1.13
  *) httest: Fixed _SSL:RENEG_CERT Bug. Without "verify" option
             _SSL:RENEG_CERT did not get certificate with its handshake and
	     that was not the idea.

  *) packages: Nicolas Perrenoud will put httest into gentoos overlay system
               and corrected the ebuild for httest.


Changes with httest 2.1.12
  *) httest: Enhance Lua interface with coder functions like sha1 md5 base64.

  *) httest: Simple websocket support based on version 13. Testet against
             Chrome Browser with websocket version 8 and
	     ws://echo.websocket.org.


Changes with httest 2.1.11
  *) httest: Enhance Lua interface with transport functions.

  *) configure: Solve sed problem with some unix derivates.

  *) httest: Fixed problems with the _ERROR body and failed SSL connections in
             there.


Changes with httest 2.1.10
  *) httest: Did not work without Lua is fixed. Thanks to Pascal Buchbinder
             and Alain Stalder for reporting this issue.

  *) httest: Fixed shell problems with configure script. Hope this works now,
             could not reproduce the problem of missing -lm. Thanks to Pascal
	     Buchbinder for reporting this issue.
	     

Changes with httest 2.1.9
  *) httest: Extend command _RES with a special parameter INGORE_MONITORS,
             which do activly ignore peeking connections without any data.


Changes with httest 2.1.8
  *) httest: Add setter/getter for log level. Old command still available.

  *) httest: Refactoring code and remove duplicated functions in worker.c and
             tcp_module.c.

  *) httest: Add define for openssl libraries without SSLv2 support, thanks to
             Eva Ramon for reporting this issue.

  *) httest: Add version command.

  *) httest: Embed an experimental httest interpreter into Lua. 


Changes with httest 2.1.7
  *) configure: Correct --with-lua5.1 option.


Changes with httest 2.1.6
  *) plugins: Add embedded Lua syntax support.

  *) httest: Added experimental Lua module, for full Lua power in httest. This
             needs liblua5.1 and its development header files.

  *) plugins: Maintained the vim plugin and added all new commands.

  *) httest: Simplyfied syntax of _LOOP, _IF, _RPS, _BPS and all other local
             bodies. New you can close a local body with "_END" instead of 
             "_END IF", "_END LOOP", ...


Changes with httest 2.1.5
  *) httest: Bugfix segfault on solaris.

  *) httest: Changed inline commands, they must start with $ and not @ and
             must have round braces with zero or more space separated
						 arguments.


Changes with httest 2.1.4
  *) httest: Fixed include problem with wrong recursiv detection. 

  *) httest: Add a SOCKS module to connect to SOCKS proxy i.e. ssh SOCKS
             tunnel. Usefull to connect to target in another network.

  *) httest: Add _UNSET command to unset a variable. This is a preparation
             for hash variables, to be able to add/remove hash entries with
	     _SET and _UNSET.


Changes with httest 2.1.3
  *) httest: Fixed automatic content length calculation if used _BINARY:SEND.


Changes with httest 2.1.2
  *) httest: Serious fix: Local variable scrambles line.

  *) httest: pop3 and smpt are brocken, they can only receive first multi line
             message, seconde will not be recognised as a multi line answer.


Changes with httest 2.1.1
  *) httest: Can not call blocks defined after caller fixed.

  *) httest: Removed implizit _FLUSH in _SOCKSTATE command.


Changes with httest 2.1.0
  *) httest: New minor release is based on httest 2.0.8. New minor release do
             have a completly refactored httest. The goal is to strip down the
	     core engine to the minimum and implement every fancy
	     functionality in modules. This do also have the benefit to make
	     httest more stable.

  *) httest: Module support for clearer code capsulation.

  *) httest: Link old commands to new commands which were moved to
             corresponding modules. This makes it possible to run old scripts
	     without rewriting them.

  *) httest: Send/receive hex digits as binary data, usefull for binary
             protocol testing. 

  *) httest: Mirgrate SSL related stuff into a new ssl module.

  *) httest: SSL certs, key and ca handling is overwritten. New you can change
             or remove certs, keys and ca for a SSL connection.

  *) httest: Mirgrate date related stuff into a new date module.

  *) httest: Improved memory handling and reduced memory leakage.


Changes with httest 2.0.8
  *) htntlm: Removed compile warnings

  *) httest: Automatic 100 continue support for requests.

  *) httest: Ssl connect and accept command which can be run on a TCP
             connection. With this command even POP3 with TLS is possible
	     either for server or client. The test pop3_tls.htt demonstrates
	     the useage of this new commands.

  *) httest: A global lock for synchronize CLIENT SERVER script parts.

  *) httest: A global lock for synchronize CLIENT SERVER script parts.

  *) user-guide: Add httest version


Changes with httest 2.0.7
  *) httest: Changed the --debug option for script debugging and add a
     --debug-system for logging more system details.

  *) httest: Bugfix coredump if using _SOCKET before any _RES or _REQ.

  *) httest: Add a test for piplining requests.

  *) httest: Use the new style safestack from openssl instead of the old
     stack. Compiles and works now also under openssl 1.0.0. 

  *) httest: Marked command _PEER_VERIFY as depreciated. Use "_RENEG verify"
     instead. This command will be removed in the next minor release.

  *) users-guide: Syntax, structure and commands are documented. Updated by
     Marcel Schoen.


Changes with httest 2.0.6
  *) httest: Serious fix: _IF "<string>" NOT EQUAL still not work.

  *) httest: Add local variable support with command _LOCAL <var>+

  *) httest: Command list is now sorted, makes it easier to get an overview.

  *) httest: Improved the vim colour coding plugin. 

  *) httest: Tabs before local commands are also allowed.

  *) httest: Serious fix: _EXEC echo "foo('bar')" do not work anymore.


Changes with httest 2.0.5
  *) httest: Simplyfied the pool usage and more fixes to make it stable.


Changes with httest 2.0.4
  *) httest: Serious fix: _IF "<string>" NOT EQUAL "<string>" is not equal
     the if condition do not execute its execute its body. This can lead to
     tests which should fail but do not.

  *) httest: Fixed memory consumption while reading files or piped _EXEC.


Changes with httest 2.0.3
  *) httest: Fixed _IGNORE_BODY did not complain if not on or off. If wrong
     written default is "off". If set to "on " _IGNORE_BODY command do not
     turn this feature on because of the space after "on".

  *) httest: Fixed big chunked Data do consume much more memory than the size
     of the received data. This could lead into a out of memory situation.

  *) httest: SSL do log more infos on SSL handshake error.

  *) httest: SSL_OP_NO_TICKET is available in openssl 0.9.8f did add a compile
     check to avoid compile errors with older openssl versions.


Changes with httest 2.0.2
  *) httest: Fixed sSL bugfixes and refactoring.

  *) httest: Fixed uninitialized variable in command _CHECK do cause false
     positive failures.

  *) httest: Fixed bug session reuse do work now. With older openssl the
     session id was empty.

  *) httest: New _IGNORE_BODY command.


Changes with httest 2.0.1
  *) httest: New _READLINE and _RECV can turn off check match/expects. This
     check can be done with a separated command _CHECK.

  *) macros: New simple POP3 implementation.

  *) httest: Fixed bugfix icap encapsulated reader.


Changes with httest 2.0.0
  *) httest: New syntax improvements for better DSL ability

  *) httest: New automatic cookie handling

  *) httest: New local variables useful for BLOCK

  *) httest: New bLOCK signatur with parameter and return values

  *) httest: New add missing _ELSE for _IF command

  *) httest: New add command _ERROR <error> ... _END ERROR to define an error
     which must occure with in this body.

  *) macros: New simple get and post request for Application testing

  *) macros: New simple SMTP implementation 


Changes with httest 1.18.0
  *) httest: New _RESWAIT combines the _RES and _WAIT command ignoring TCP
     connections not sending any data.


Changes with httest 1.17.0
  *) httest: New _PROCESS command to run a part of the script with in a
     separated process and wait with _PROC_WAIT for its termination. Only
     available on unix systems.

  *) httest: New global command PROCESS to run the same script in multiple
     processes, maybe usefull for performance testing. Only available on unix
     systems.

  *) httest: New automatic length information support for ICAP Encapsulated
     header


Changes with httest 1.16.0
  *) httest: New openssl engine support to use crypto devices.

  *) httest: New _MATCH do also have "." as namespace, like _EXPECT.

  *) httest: New _EXPECT do also have "Headers" and "Body" as namespace, like
     _MATCH.

  *) httest: New _GREP works like _MATCH but do not fail if no match.

  *) httest: New global command AUTO_CLOSE to handle automatical Connection
     header value "close".

  *) httest: New _AUTO_CLOSE same as global command AUTO_CLOSE.

  *) httest: New _SSL_CERT_VAL getting values from a cert.


Changes with httest 1.15.0
  *) httest: New _REQ/SERVER command supports IPV6 (address surrounded in
     square brackets).

  *) Fixed htproxy: does not record data any more.

  *) httest: Fixed help text typo.


Changes with httest 1.14.2
  *) httest: Fixed coredump on receiving negative content length header 

  *) httest: Changes  httest: Supports OpenSSL 0.9.8m Legacy TLS renegotiation is still
     enabled.


Changes with httest 1.14.1
  *) httest: Fixed _IF condtions with GT/LT/EQ did ignore sign, i.e. -100 > 4


Changes with httest 1.14.0
  *) httest: New _RPS request per second loop implemented


Changes with httest 1.13.3
  *) httest: Changed deal with new openssel 0.9.8l which do remove
     renegotiation because of a security hole (man in the middle attack).
     Httest should be still able doing renegotiation, it is a test tool.


Changes with httest 1.13.2
  *) httest: Changed only ON_ERROR is noisy, FINALLY block is silent
  *) httest: Improved httest: System variable __LOG_LEVEL, can be used to make FINALLY
     block noisy if needed


Changes with httest 1.13.1
  *) httest: Fixed multithreaded client/server test terminate before all work
     is done, cause they are all started detached and uncontrolled.


Changes with httest 1.13.0 - Improved httest: Help text

  *) httest: Changed block FINALLY and ON_ERROR are noisy again

  *) httest: Improved httest: __STATUS system variable also available in ON_ERROR block

  *) httest: Improved httest: __THREAD system variable for FINALLY and ON_ERROR block

  *) httest: New with ON_ERROR block error handling is hand over to user 

  *) httest: Changed removed depreciated command _IGNORE_ERRORS


Changes with httest 1.12.5
  *) httest: Fixed coredump while print debug info on _EXEC process
                    termination


Changes with httest 1.12.4
  *) httest: Fixed do not url encode "+"

  *) httest: Improved httest: if read huge lines, httest will grow exponentaly in memory

  *) httest: Fixed socket eof reader do hold only the last 8KB

  *) httest: Improved httest: Read _EXEC output in one peace instead line by line

  *) httest: Fixed reading/writing file from/to pipe do not work properly

  *) httest: Fixed data need to be null terminated for regex even binary data

  *) httest: Improved httest: Base64 encoding/decoding support


Changes with httest 1.12.3
  *) Fixed htntlm: Do not work on big endian machine 

  *) httest: Fixed _URLENC do not understand \x<hex-digit><hex-digit>

  *) Fixed htntlm: No session-key and flags set in type 3 message
  *) httest: Improved htntlm: Read given base64 message first before setting options


Changes with httest 1.12.2 - Improved httest: Show command specific help
  *) Fixed htntlm: Windows do not understand <number>LLU

  *) Fixed htntlm: Challenge hexd string used without translate to binary

  *) Fixed htntlm: incorrect LM2 and NTLM2 hash calculation

  *) New htntlm: NTLM2 signing and sealing scheme


Changes with httest 1.12.1
  *) httest: Fixed if expects/matchs rules exist network error not visible

  *) Fixed htntlm: Add missed unicode support (very basic)

  *) httest: Improved htntlm: Add lm2 and ntlm2 support

  *) httest: Improved httest: Listener can be bound on a IP, scope id and port

  *) httest: Fixed did not validate match and expect scope "VAR"

  *) httest: Improved httest: Add command _URLDEC to decode encoded urls


Changes with httest 1.12.0
  *) New htntlm: Can read/write NTLM messages

  *) Fixed htproxy: Crash on windows if read configuration file

  *) Fixed hturlext: Crash if called with no arguments


Changes with httest 1.11.0
  *) httest: Fixed _BPS help text is incomplete

  *) httest: Fixed _BPS loops for ever if high bandwidth is defined

  *) httest: Fixed _EXEC suppress last char if not terminated with a \n

  *) httest: Improved hturlext: Add a filter to exclude tags and/or attributes

  *) httest: Improved httest: Improved usage and version text and add long options

  *) httest: Improved htproxy: Improved usage and version text and add long options

  *) httest: Improved htremote: Improved usage and version text and add long options

  *) httest: Improved Add man pages for all binaries


Changes with httest 1.10.2
  *) httest: Fixed deadlock situation seen under windows


Changes with httest 1.10.1
  *) httest: Fixed _OP command did a wrong type cast


Changes with httest 1.10.0
  *) httest: Fixed client connect before server listener is up

  *) httest: Fixed temp file leakage on failure

  *) httest: New _MATCH scope to match variables directly

  *) httest: Fixed incorrect formated error output

  *) httest: Improved httest: _EXEC| and _EXEC< also work for _READLINE and _RECV

  *) New htproxy: Setup with a configuration file


Changes with httest 1.9.0
  *) httest: If download huge files, httest will grow exponentaly in memory
     fixed

  *) httest: New command to print duration time [ms]

  *) httest: New system variables: __STATUS and __START_TIME

  *) httest: Do for each command implemented

  *) httest: Improved _IF command, can handle now [NOT] MATCH|EQ|LT|GT|LE|GE

  *) httest: htpcap: Removed


Changes with httest 1.8.0
  *) httest: _BREAK to interrupt a loop

  *) httest: Extend _RECV with "Chunked" and "Close"

  *) httest: _PRINT_HEX command to print and match hex output

  *) httest: Write to file with a loop to be sure we realy write the hole buf

  *) httest: BLOCK / _CALL can handle arguments

  *) httest: Bugfixed _SOCKSTATE command, handle no peeklen correctly

  *) httest: Do handle Connection: close header incorrect on server side

  *) httest: Bugfix possible division by zero in the _BPS command

  *) httest: Bugfix the strftime command for windows

  *) httest: Windows combatibilty patches for httest, htproxy, htremote and htpcap


Changes with httest 1.7.1
  *) httest: _RENEG command do not work, nor does _VERIFY_PEER work correctly

  *) htproxy: Do not compile on solaris

  *) httest: htpcap: Do not compile on solaris


Changes with httest 1.7.0
  *) httest: Improved release build script

  *) httest: Add _READLINE command to read a line terminated with \r\n or \n

  *) httest: Add _RENEG command. Performs an SSL renegotiation.

  *) httest: Add _TUNNEL command. Build up a tunnel to another server.

  *) htproxy: Add _EXPECT before last _WAIT works now in all cases

  *) httest: htremote: Control interactiv shell commands over TCP/IP for testing
     purpose


Changes with httest 1.6.1
  *) httest: Improved testsuite, more checks for release build 

  *) httest: Bugfix all client/server called the finally block

  *) httest: Reformat the output of httest -L


Changes with httest 1.6.0
  *) httest: Bugfix command _WAIT <bytes>

  *) httest: Add command to spawn a socket reader over a set of _WAIT/_RECV
 

Changes with httest 1.5.2
  *) httest: _STRFTIME can choose between Local and GMT


Changes with httest 1.5.1
  *) httest: Bugfix, use local time for STRFTIME


Changes with httest 1.5.0
  *) httest: Embedded file implementation

  *) httest: Add new expect scope exec to expect patterns from _EXEC stdout

  *) httest: Add new command _STRFTIME to print a number time formated

  *) httest: Command _OP operates now with long long instead of int, avoids
     overflow wiht time calculations

  *) httest: Overworked the testsuit, do tests more exactly more detailed


Changes with httest 1.4.1
  *) httest: Add check if include headers exist with APR_HAVE_XXX for windows
     build

  *) httest: Bugfix cordump in _URLENC


Changes with httest 1.4.0
  *) httest: Add _URLENC command to encode a string for post requests

  *) httest: Add _EXEC< command to filter a receiving http stream (i.e. deflate)

  *) httest: Bugfix missing file and line output on error, add a test


Changes with httest 1.3.4
  *) httest: Bugfix bug #2644424 segfault on solaris with the _EXEC command

  *) httest: Bugfix bug #2645093 _RECV POLL allways end with the incomplete
     error


Changes with httest 1.3.3
  *) httest: Bugfix body output, do not skip empty lines


Changes with httest 1.3.2
  *) httest: Bugfix missing null termination on file EOF

  *) httest: Reactivate displaying stdout of EXEC

  *) httest: Bugfix wrong chars in variables do not fail


Changes with httest 1.3.1
  *) httest: Throws incomplete error if content is incomplete.

  *) httest: _EXEC did not read last line without a newline


Changes with httest 1.3.0
  *) httest: Embedded shell scripts

  *) httest: Add new match scope exec to cut from _EXEC stdout

  *) httest: Bugfix the encapsulated content reader (ICAP)

  *) httest: Bugfix a problem if no HTTP headers (HTTP/0.9)


Changes with httest 1.2.2
  *) httest: Bugfix _ONLY_PRINTABLE


Changes with httest 1.2.1
  *) htproxy: Initial session only if requested via shell

  *) htproxy: If SSL tunneling via CONNECT method send back "400 Bad Request"

  *) httest: Can handle now plain HTML without HTTP headers at all (HTTP/0.9)

  *) httest: Add command _ONLY_PRINTABLE to replace non printable chars with a space


Changes with httest 1.2.0
  *) httest: Bandwidth restriction command

  *) httest: Inherit the enviroment variables to commands called through _EXEC


Changes with httest 1.1.0
  *) htproxy: Generate automated httest scripts

  *) htproxy: Support for automatical MATCH for cookies

  *) htproxy: Replace host and port with customized variable names

  *) htproxy: Admin interface over stdin to control the htproxy

  *) httest: Bugfix error code for _VERIFY_PEER is now EACCES and not EINVAL

  *) httest: Bugfix problem while reading headers with values containing ":"


Changes with httest 1.0.3 
  *) httest: Bugfix data loss while using _SOCKSTATE command

  *) httest: Bugfix segfault if useing accidentaly the same port for plain and ssl
   connection 

  *) httest: Marked _IGNORE_ERR as depricated

  *) httest: Bugfix spaces instead of tabs in the generated ebuild


Changes with httest 1.0.2 
  *) httest: Bugfix configure script

  *) httest: Bugfix critical problem with sending data


Changes with httest 1.0.1 
  *) httest: Add --with-apr, --with-apr-util, --with-pcre and with-ssl to configure
     script to specify alternativ libs

  *) httest: Add --enable-use-static to force the linker to use archives where ever
     possible instead of shared libraries

  *) httest: Add --enable-full-static to build a static binary


Changes with httest 1.0.0 
  *) httest: Classical configure && make && install mechanisme added

  *) httest: Load server certs in SERVER command only if they are there

  *) httest: Overworked test suit to fit make check and make distcheck


Changes with httest 0.12.2 
  *) httest: Suppress start line with OK|FAILED option

  *) httest: Check if SSL is enabled when calling _CERT

  *) httest: Check if SSL port is set


Changes with httest 0.12.1 
  *) httest: Bugfix gentoo package


Changes with httest 0.12.0 
  *) httest: Extend REQ command with a tag to hold multiple connections to same target

  *) httest: MATCH improved, ERROR added like EXPECT ERROR 

  *) httest: Bugfix error text for negated EXPECT clauses

  *) httest: Peer certificate verification command _VERIFY_PEER

  *) httest: Extend _REQ and _CERT to add a CA certificate


Changes with httest 0.11.2 
  *) httest: Bugfix line reader to get headers 

  *) httest: Bugfix error trace on failure

  *) httest: Bugfix possible coredump on startup if server port is missing


Changes with httest 0.11.1 
  *) httest: Match/Expect regular expression can now be encolsed with any char, 
     escaping support

  *) httest: Close listener if server terminates (and all its started servers)


Changes with httest 0.11.0 
  *) httest: Match/Expect also supports single quotes to enclose the regular expression

  *) httest: Match with more than one variable assignment

  *) httest: _RECV POLL takes now the socket timeout set by _TIMEOUT


Changes with httest 0.10.0 
  *) httest: Add a final block called on exit

  *) httest: Set cert/key for ssl used for example to set a alternativ server cert 


Changes with httest 0.9.1 
  *) httest: Stability patches


Changes with httest 0.9.0 
  *) httest: Add getter method for workers concurrency number

  *) httest: Add math operations: ADD, SUB, MUL, DIV 

  *) httest: Bugfix warnings appeare under solaris

  *) httest: Bugfix problem with global EXEC on failure


Changes with httest 0.8.1 
  *) httest: Better log out

  *) httest: Better syntax check

  *) httest: LOOP statement with a FOREVER value

  *) httest: Add scripts for distributed script calling

  *) httest: Add scripts for rampup performance tests

  *) httest: Bugfix problem with unknown Connection headers


Changes with httest 0.8.0 
  *) httest: Receive in polling mode

  *) httest: Can manage more than one socket per CLIENT/SERVER

  *) httest: Every command has now variable resolving

  *) httest: Remove base64 encoding/decoding will do it external (later)


Changes with httest 0.7.2 
  *) httest: Overworked the help text

  *) httest: Enviroment variable support

  *) httest: Receive an amount of bytes, do not expect headers in this case

  *) httest: Wait with optional expected bytes length


Changes with httest 0.7.1 
  *) httest: Bugfix variable declaration for solaris compiler (gcc has no problem with that)

  *) httest: Bugfix base64 encode/decode did not work

  *) httest: DAEMON for supervisor jobs


Changes with httest 0.7.0
  *) httest: base64 encode/decode support

  *) httest: Sync command to synchronise timeout tests


Changes with httest 0.6.2
  *) httest: BLOCK now thread safe

  *) httest: Bugfixed problems with the msdos line termination \r\n

  *) httest: Error message now with correct filename


Changes with httest 0.6.1
  *) httest: Set log level with in script

  *) httest: Load client cert/key in _REQ command

  *) httest: Removed _SET_CERT/_SET_KEY

  *) httest: Bugfixed SET command


Changes with httest 0.6.0 
  *) httest: Load individual certs and keys for server/client
  *) httest: Define simple blocks to call them later 
  *) httest: Nested LOOP and IF implemented


Changes with httest 0.5.1 
  *) httest: Listen on any host
  *) httest: Bugfixes uninitalized variables


Changes with httest 0.5.0 
  *) httest: Add possibility to store time in ms to a variable


Changes with httest 0.4.4 
  *) httest: Fixed the help text again

  *) httest: Bugfix a segfault in the _IF command

  *) httest: Bugfix unknown Connection: keep-alive

  *) httest: Reworked the log modes


Changes with httest 0.4.3 
  *) httest: Server _UP/_DOWN feature

  *) httest: WAIT [<size>] feature


Changes with httest 0.4.2 
  *) httest: Bugfix EXPECT ERROR handling

  *) httest: Fixed stability problems


Changes with httest 0.4.1 
  *) httest: Improved EXPECT handling


Changes with httest 0.4.0 
  *) httest: ICAP support


Changes with httest 0.3.0 - Many fixes around the coredump problematic
  *) httest: Imporved pool stragtegy and reduce memory usage 


Changes with httest 0.2.3 - Pipe received data to a shell command line
  *) httest: A simple _LOOP command

  *) httest: _IF overworked


Changes with httest 0.2.2 - Improved server performance
  *) httest: Improved error reporting

  *) httest: Solved broken pipe problem by ignoring SIGPIPE signal

  *) httest: Add a possibility to ignore all errors within a child or server

  *) httest: Pipe binary data support

  *) httest: Add possibility to force an exit and return OK or FAILED

  *) httest: Improved header allow, add filter possibilty to force for example HTTP/1.0 client


Changes with httest 0.2.1 - Get the socket state for reconnect 
  *) httest: Cleaner variable processing 

  *) httest: Server side SSL support

  *) httest: Segfault on a single 0 chunk fixed


Changes with httest 0.2.0 - Refactoring of the global commands
  *) httest: Simple shell

  *) httest: Cleaner log output


Changes with httest 0.1.2 - Allowed header filter (Client only) 
  *) httest: Pipe _EXEC output into the HTTP stream 

  *) httest: Use variables even in _EXPECT and _MATCH commands 

  *) httest: Send data without a CRLF at the end


Changes with httest 0.1.1 - If command 
  *) httest: Shell command execution 


Changes with httest 0.1.0 - Can act as client and server 
  *) httest: Concurrency 

  *) httest: Looping - do one job many times for performance measurement

  *) httest: Enhanced variable support 

  *) httest: Check response on defined expects 

  *) httest: Include files 

  *) httest: SSL support (SSL23, SSL3, SSL2, TLS1) 

  *) httest: Autocompletion for Content-Length 

  *) httest: Full chunked encoding data support
